// ListViewTestMFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ListViewTestMFC.h"
#include "ListViewTestMFCDlg.h"
#include ".\listviewtestmfcdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CListViewTestMFCDlg dialog



CListViewTestMFCDlg::CListViewTestMFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListViewTestMFCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CListViewTestMFCDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_LIST1, m_listCtrl);
  DDX_Control(pDX, IDC_EDIT1, m_txtColumns);
  DDX_Control(pDX, IDC_EDIT2, m_txtRows);
}

BEGIN_MESSAGE_MAP(CListViewTestMFCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CListViewTestMFCDlg message handlers

BOOL CListViewTestMFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
  this->m_listCtrl.ModifyStyle(LVS_TYPEMASK, LVS_REPORT);
  this->m_txtRows.SetWindowText(_T("500"));
  this->m_txtColumns.SetWindowText(_T("20"));
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CListViewTestMFCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CListViewTestMFCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CListViewTestMFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CListViewTestMFCDlg::OnBnClickedOk()
{
  CString tmp;
  this->m_txtColumns.GetWindowText(tmp);
  int cols = _tstoi(tmp);
  this->m_txtRows.GetWindowText(tmp);
  int rows = _tstoi(tmp);

  for(int i=0; i<cols; i++)
  {
    tmp.Format(_T("Col%d"), i);
    this->m_listCtrl.InsertColumn(i, tmp, LVCFMT_LEFT, 100, i);
  }
  for (int j=0; j<rows; j++)
  {
    tmp.Format(_T("Item%d"), j);
    this->m_listCtrl.InsertItem(j, tmp);
    for (int k=1; k<cols; k++)
    {
      tmp.Format(_T("Item%d-SubItem%d"), j, k);
      this->m_listCtrl.SetItemText(j, k, tmp);
    }
  }
}
